/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.c 117 2009-01-29 17:21:26Z ertl-honda $
 */

/*
 * ꥢI/OǥХSIO˥ɥ饤СNIOS2_DEVѡ
 */
#include <kernel.h>
#include "target_syssvc.h"
#include "jtag_uart.h"
#include "target_serial.h"

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_PORT] = {
	{
		(void*)(JTAG_UART_1_BASE + JTAG_UART_CONTROL_OFFSET),
		(void*)(JTAG_UART_1_BASE + JTAG_UART_DATA_OFFSET),
		(uint32_t)INTNO_SIO_PORT1
	},
#if TNUM_PORT >= 2
	{
		(void*)(JTAG_UART_2_BASE + JTAG_UART_CONTROL_OFFSET),
		(void*)(JTAG_UART_2_BASE + JTAG_UART_DATA_OFFSET),
		(uint32_t)INTNO_SIO_PORT2
	},
#endif /* TNUM_PORT >= 2 */
#if TNUM_PORT >= 3
	{
		(void*)(JTAG_UART_3_BASE + JTAG_UART_CONTROL_OFFSET),
		(void*)(JTAG_UART_3_BASE + JTAG_UART_DATA_OFFSET),
		(uint32_t)INTNO_SIO_PORT3
	},
#endif /* TNUM_PORT >= 3 */
#if TNUM_PORT >= 4
	{
		(void*)(JTAG_UART_4_BASE + JTAG_UART_CONTROL_OFFSET),
		(void*)(JTAG_UART_4_BASE + JTAG_UART_DATA_OFFSET),
		(uint32_t)INTNO_SIO_PORT4
	},
#endif /* TNUM_PORT >= 4 */
};
